var URLtoXML = {
	outTXT : "",// строка, куда соберем список
	fMode : true, // режим обмена данными (асинхронный=true синхронный=false)

	nStart : 0, // начальный символ поиска в ответе нужных данных

	xmlHTTP : null,
	xmlHTTPDescr : null,

	sName : new Array(), // имя файла
	UrlSt : new Array(), // адрес
	ImgDickr : new Array(), // картинка
	pName : new Array(),
	pDes : new Array(),
	qDes : new Array(),
	
	folders: new Array(),

	pUrlSt : new Array(),
	WpUrlSt : new Array(),

	arrVideoExt : ["avi", "asf", "asx", "3gp","3g2", "3gp2", "3gpp", "flv", "mp4", "mp4v", "m4v", "m2v","m2ts", "m2t", "mp2v", "mov", "mpg", "mpe", "mpeg", "mkv","swf", "mts", "wm", "wmx", "wmv", "vob", "iso", "f4v", "ts", "flac", "mp3", "dts", "ac3", "divx"],
   
   //двумерный массив строк, которые нужно заменить в тексте - первый вариант на второй
   arrReplWordsDesc : [["h1>", "b>"], ["</*p>","<br>"], ["\\s*<br>\\s*<br>", "<br>"], ["</*p>","</*p>"]],
   arrReplWordsFrwd : [["&", "&amp;"], ["<", "&lt;"], [">", "&gt;"], ["'", "&apos;"], ["\"", "&quot;"]],
   //массив строк-масок регулярных выражений, подлежащих удалению из текста
   arrDelWords : ["<\\s*a[^<^>]*>", "<\\s*/\\s*a\\s*>", "<\\s*/*\\s*span[^>]*>", "<\\s*/*\\s*div[^>]*>", "<\\s*/*\\s*img[^>]*>", "<\\s*/*\\s*strong[^>]*>"],
   prefixTAG : "<a href='",
   endedTAG : "'>",
   mpHttpResponseParser : null
};

URLtoXML.deinit = function () {
	if (this.xmlHTTP ) {
		this.xmlHTTP.abort();
	}
};

URLtoXML.SetHtmlParser = function(pHtmlParser){
	URLtoXML.mpHttpResponseParser = pHtmlParser;
};

// обработка ссылки
URLtoXML.Proceed = function(sURL) {
	this.outTXT = "";// очищаем строку-приемник конечного плейлиста
	if (this.xmlHTTP == null) {// инициализируем связь с интернетом
		Main.showLoading();
		alert (sURL);
		this.xmlHTTP = new XMLHttpRequest();

		this.xmlHTTP.url = sURL;

		// отсылаем пустой запрос и ловим страницу в строку
		this.xmlHTTP.open("GET", sURL, this.fMode); // ?асинхронно

		this.xmlHTTP.onreadystatechange = function() {
			if (URLtoXML.xmlHTTP.readyState == 4) {
				if(URLtoXML.mpHttpResponseParser != null){
					URLtoXML.mpHttpResponseParser();
					URLtoXML.mpHttpResponseParser = null;
					Main.hideLoading();
				}
				else{		
					URLtoXML.outTXT = URLtoXML.ParseXMLData(); // генерим конечный плейлист на основании полученных данных
					Main.hideLoading();
				}
			}
		};

		this.xmlHTTP.setRequestHeader("User-Agent","Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.9.168 Version/11.51");
		this.xmlHTTP.send();
	}
	this.getPageDescr();
};

URLtoXML.getPageDescr = function() {
	if (this.pDes[Main.index]=='' && Main.playlist==1){
		Main.showLoading(1);
		
		this.xmlHTTPDescr = null;
		this.xmlHTTPDescr = new XMLHttpRequest();
		
		this.xmlHTTPDescr.open("GET", this.UrlSt[Main.index], true); // ?асинхронно

		this.xmlHTTPDescr.onreadystatechange = function() {
			if (URLtoXML.xmlHTTPDescr && URLtoXML.xmlHTTPDescr.readyState == 4) {
				URLtoXML.ParsePageDesctData(); // генерим конечный плейлист на основании полученных данных
				Main.hideLoading(1);
			}
		};
		this.xmlHTTPDescr.setRequestHeader("User-Agent","Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.9.168 Version/11.51");
		this.xmlHTTPDescr.send();
	}
};

URLtoXML.ParsePageDesctData = function() {
	var sOut;
	if (this.xmlHTTPDescr.status == 200){
		sOut = this.xmlHTTPDescr.responseText;
		
//		alert('----------------------------------');
		var descr;
		sOut = sOut.substr(0,200000);
		var myRe = new RegExp("\<div class=\"item-info\"\>[\\s\\S]*(\<table\>[\\s\\S]*\<\/table\>)[\\s\\S]*(\<div class=\"b-tab-item__vote-value m-tab-item__vote-value_type_yes\"\>\\d+\<\/div\>)[\\s\\S]*(\<div class=\"b-tab-item__vote-value m-tab-item__vote-value_type_no\"\>\\d+\<\/div\>)[\\s\\S]*\<p( class=\"item-decription \\w+\")?\>([\\s\\S]*)\<\/p\>[\\s\\S]*\<div class=\"b-scroll-to\"\>","igm");
		if (descr = myRe.exec(sOut)){
//			descr[1] = descr[1].replace("&nbsp;"," ");
			descr[5] = descr[5].replace(new RegExp("([\\s\\S]*)\<\/p\>([\\s\\S]*)",'igm'),"$1");
			
			this.pDes[Main.index] = '<div class="votes">'+descr[2]+descr[3]+'</div>'+descr[1]+descr[5];
			this.pDes[Main.index] = this.pDes[Main.index].replace("&nbsp;"," ");
			
			widgetAPI.putInnerHTML(document.getElementById("description"),
				"<img align='left' src='"
					+ this.ImgDickr[Main.index] + "'/>"
					+ this.pDes[Main.index]);
/*			alert(descr[1]);
			alert('----------------------------------');
			alert(descr[3]);
*/
		}
//		alert('----------------------------------');
	}
};

// из полученного ответа вытаскиваем нужные данные
URLtoXML.ParseXMLData = function() {
	var sOut;
	var index = 0; // индекс масcива

	if (this.xmlHTTP.status == 200)// если ответ от сервера корректный
	{
		sOut = this.xmlHTTP.responseText;
		
		var myRe;

		if (Main.playlist == 0) {
			if (Main.search){
				var arr = sOut.split('<td class="num">');
				
				for (var i in arr) {
					myRe = new RegExp("\<a href=\"(.*)\" class=\"title\"\>(.*)\<\/a\>","ig");
					if (name = myRe.exec(arr[i])){
						index++;
						this.UrlSt[index] = Main.prefixURL + name[1] + '?ajax&folder=0';
						this.sName[index] = name[2];

						myRe = new RegExp("\<a href=\".*\" title=\".*\"\>\<img src=\"(.*)\/5\/(.*)\" border=\"0\"\>\<\/a\>","ig");
						if (img = myRe.exec(arr[i])){
							this.ImgDickr[index] = img[1]+'/6/'+img[2];
						}else{
							this.ImgDickr[index] = '';
						}

						arr[i] = arr[i].replace(new RegExp("\<br\\s?\/\>(\\s*)?\\r?\\n?","igm"), '<br/>');
						myRe = new RegExp("\<p class=\"text\"\>((.|\\n)*)\<\/p\>\\n","igm");
						if (desc = myRe.exec(arr[i])){
							desc[1] = URLtoXML.DelWords(desc[1]);
							desc[1] = URLtoXML.DelTrash(desc[1]);
							
							this.pDes[index] = desc[1];
						}else{
							this.pDes[index] = '';
						}
						
						
						widgetAPI.putInnerHTML(document.getElementById("title"), this.sName[Main.index]);
						widgetAPI.putInnerHTML(document.getElementById("bloc" + index), "<img class='blockImage' id='imgst" + index +  "';  src='" + this.ImgDickr[index] + "' />");
						//document.getElementById("imgst" + Main.index).style.borderColor = "#3399FF"; // активная строка
						document.getElementById("imgst" + Main.index).style.borderColor = "#FF6600"; // активная строка

					}else{
						this.UrlSt[index] = '';
						this.sName[index] = '';
						this.pDes[index] = '';
						widgetAPI.putInnerHTML(document.getElementById("bloc" + index), "");
					}
				}
						//var x=document.getElementById("spisok");
						//alert(x.innerHTML);
			}else{
			
				var arr = sOut.split('<div class="b-poster-section ');
				for (var i in arr) {
					myRe = new RegExp("\<a class=\"subject-link\" href=\"(.+)\" title=\".+\"\>","igm");
					if (url = myRe.exec(arr[i])){
						index++;
						this.UrlSt[index] = Main.prefixURL + url[1];
						
						myRe = new RegExp("\<img src=\"(.*)\" alt=\'(.*)\'\/\>","igm");
						if (img = myRe.exec(arr[i])){
							this.ImgDickr[index] = img[1];
						}
						
						myRe = new RegExp("\<b class=\"b-poster-info\"\>\\n\\s*((.|\\n)*)\\n\\s+\<b class=\"num \"(.|\\n)*\<\/b\>\\n\\s*\<span\>","igm");
						quality = '';
						if (qual = myRe.exec(arr[i])){
							quality = '<b class="b-poster-info">'+qual[1]+'</b>';
						}
						
						myRe = new RegExp("\<b class=\"subject-link m-full\"\>\\n.*\\n\\s*\<span\>(.*)\<p\>(.*)\<\/p\>\<p\>(.*)\<\/p\>\<\/span\>\\n\\s*\<\/b\>","igm");
						if (name = myRe.exec(arr[i])){
							this.sName[index] = name[1]+' '+name[3];
						}else{
							myRe = new RegExp("\<b class=\"subject-link m-full\"\>\\n.*\\n\\s*\<span\>(.*)\<p\>(.*)\<\/p\>\<\/span\>\\n\\s*\<\/b\>","igm");
							if (name = myRe.exec(arr[i])){
								this.sName[index] = name[1]+' '+name[2];
							}
						}
						
						this.pDes[index] = '';
						
						widgetAPI.putInnerHTML(document.getElementById("title"), this.sName[Main.index]);
						widgetAPI.putInnerHTML(document.getElementById("bloc" + index), "<img class='blockImage' id='imgst" + index +  "';  src='" + this.ImgDickr[index] + "' />"+quality);
						//document.getElementById("imgst" + Main.index).style.borderColor = "#3399FF"; // активная строка
						document.getElementById("imgst" + Main.index).style.borderColor = "#FF6600"; // активная строка
					
					}else{
						this.UrlSt[index] = '';
						this.sName[index] = '';
						this.pDes[index] = '';
						widgetAPI.putInnerHTML(document.getElementById("bloc" + index), "");
					}
				}
			}
		}else if (Main.playlist == 1) { 
			var id;
			
			var obj = new Object();
			obj.names = new Array();
			obj.urls = new Array();
			obj.isFolders = new Array();
			obj.currIdx = 1;
			
			var arr = sOut.split('<li class="folder">');
			for (var i in arr) {
//				var myRe = /\<a .* name=\"fl\d+\" class=\"link-\w+\s?(\S*)?\s?title" rel="{parent_id: '?(\d+)'?}">(\n\s*)?(.+)\<\/a\>/igm;
				myRe = new RegExp("\<a .* name=\"fl\\d+\" class=\"link-\\w+\\s?(\\S*)?\\s?title\" rel=\"{parent_id: '?(\\d+)'?}\"(\\sstyle=\".*\")?\>(\\n\\s*)?(.+)\<\/a\>","igm");
				if (id = myRe.exec(arr[i])){
				
//						id[1] - ikonka lang
//						id[2] - id
//						id[5] - Perevod name

//					myRe = /\<a href=\"\/(.*)\" class=\"folder-filelist\">.*\<\/a\>/igm;
//					var fl = myRe.exec(arr[i]);
//						fl[1] - file list url						
					
					myRe = new RegExp("\<span class=\"material-size\"\>(.*)\<\/span\>\\n.*\<span class=\"material-size\"\>(.*)\<\/span\>","igm");
					var ms = myRe.exec(arr[i]);
					if (!ms){
						myRe = new RegExp("\<span class=\"material-size\"\>(.*)\<\/span\>","igm");
						ms = myRe.exec(arr[i]);
					}
					myRe = new RegExp("\<span class=\"material-details\"\>(.*)\<\/span\>","igm");
					var md = myRe.exec(arr[i]);
					
					var name = '<div class="link-subtype';
					if (id[1]){ name+=' '+id[1]+'">'; }else{ name+='">'; }
					if (id[5]){ name+='<span class="voice">'+id[5]+'</span>'; }
//					if (id[1]){ name+='<span class="voice">'+id[5]+'</span>'; }
//					else{ name+=id[5]; } }
					name+='&nbsp;&nbsp;';
					if (ms){
						if(ms[2]){ 
							if(ms[1]){ name+=ms[1]; }
							name+='&nbsp;&nbsp;&nbsp;('+ms[2]; 
						}else{ name+='&nbsp;&nbsp;&nbsp;('+ms[1]; }
					}
					if(md[1]){ name+=' - '+md[1]; }
					name+=')</div>';
					
					var url;
/*					var isFolder = false;
					if (fl){ 
						url=Main.prefixURL + fl[1];
					}else{ 
						url=this.xmlHTTP.url + '&folder='+id[2]; 
						isFolder = true;
					}
*/

					url=this.xmlHTTP.url + '&folder='+id[2]; 
					
					obj.names[obj.names.length] = name;
					obj.urls[obj.urls.length] = url;
//					obj.isFolders[obj.isFolders.length] = isFolder;
//					alert(isFolder+' - '+url);
										
					index++;
					widgetAPI.putInnerHTML(document.getElementById("str" + index), name);
				}
			}
			
			if (obj.urls.length>0){
				this.folders[this.folders.length] = obj;
			}else{
				Main.playlist = 2;
				Info.load();
			}
						
		}
		
		if (Main.playlist == 2) {
			this.pName = [];
			this.pUrlSt = [];
			this.WpUrlSt = [];
				
			if (Main.MATERIALL == 1) {
				//myRe = new RegExp("\'(.*\)\'.*\\n.*\\n.*\\n.*\\n.*\\n.*\" href=\"(.*\/(.*\\.(.*)))\" class=","igm");
				myRe = new RegExp("\"\>\\n(.*)\"\>[\\s\\S]{2,500}href=\"(.*\/(.*\\.(.*)))\" class=","igm");
				while (sres = myRe.exec(sOut)) {
					//alert(sres);
					if(this.arrVideoExt.indexOf(sres[4].toLowerCase())>-1){
						index++;
						this.pName[index] = decodeURIComponent(sres[3].replace(new RegExp("\\+","g"),  " "));
						this.pUrlSt[index] = Main.prefixURL + sres[2];
						//alert ("sres[1]"+sres[1]);
						wpmyRe = new RegExp("url=\"(.*)\" rel","igm");
						while (wpsres = wpmyRe.exec(sres[1])) {
							//alert ("wpsres="+wpsres[1]);
							this.WpUrlSt[index] = Main.prefixURL + wpsres[1];
						}
						widgetAPI.putInnerHTML(document.getElementById("str" + index), this.pName[index]);
					}
				}
			}
			if (Main.MATERIALL == 2) {
				myRe = new RegExp("\<a id=\".*\" href=\"(.*\/(.*\\.(.*)))\" class=\".*b-file-new__link-material-download.*\"\>\\n","igm");
				while (sres = myRe.exec(sOut)) {
					//alert (sres[0]);
					//alert (sres[1]);
					//alert (sres[2]);
					//alert (sres[3]);
					if(this.arrVideoExt.indexOf(sres[3].toLowerCase())>-1){
						index++;
						this.pName[index] = decodeURIComponent(sres[2].replace(new RegExp("\\+","g"),  " "));
						this.pUrlSt[index] = Main.prefixURL + sres[1];
						widgetAPI.putInnerHTML(document.getElementById("str" + index), this.pName[index]);
					}
				}
			}
		}
	}

};

/*
// поиск значения на странице и вычленение его
URLtoXML.FindVal = function(sOut, nBeg, keyBVal, keyEVal) {
	var nEnd, sRes;

	sRes = sOut.toLowerCase();// приводим к нижнему регистру
	nBeg = sRes.indexOf(keyBVal.toLowerCase(), nBeg);// ищем первый ключ

	if (nBeg >= 0) {// если значение найдено

		nBeg = nBeg + keyBVal.length;// передвигаем начало поиска на след.
		// символ за первичным ключом
		// ищем вторичный ключ
		nEnd = sRes.indexOf(keyEVal.toLowerCase(), nBeg);
		this.nStart = nEnd + keyEVal.length;// если не нашли окончание значения
		// - становимся в конец строки +1
		// символ

		sRes = sOut.substring(nBeg, nEnd); // вычленяем значение
	} else {
		sRes = "";// не найден первичный ключ
		this.nStart = nBeg;// конец поиска - маска не найдена
	}
	return sRes;
};
*/
// удаление "мусора" из строки
URLtoXML.DelTrash = function(str) {
	// заменяем мусор на пробелы
	str = str.replace(new RegExp("&nbsp;", 'gim'), " ");
	str = str.replace(new RegExp("&mdash;", 'gim'), " ");
	str = str.replace(new RegExp("\t", 'gim'), " "); // табуляция
	str = str.replace(new RegExp("\n", 'gim'), " "); // конец строки
	str = str.replace(new RegExp("\r", 'gim'), " "); // перевод каретки

	// заменяем все "длинные" пробелы на один
	while (str.indexOf("  ") >= 0) {
		str = str.replace(new RegExp("  ", 'gim'), " ");
	}
	return URLtoXML.trim(str);
};

//удаление исключенных слов из результата
URLtoXML.DelWords = function(sVal){
var wrd, sRes;

    sRes = sVal;
    //удаляем из входной строки все встречающиеся в массиве исключений слова
    for (var i in this.arrDelWords){
       //слово из массива
       wrd = this.arrDelWords[i];
       sRes = sRes.replace(new RegExp(wrd, 'gim'), "");
    }
    
    //возвращаем результат
    return sRes;
};
/*
//замена слов в результате по массиву замен
URLtoXML.ReplWords = function(sVal, arrRepl){
var wrd, sRes;

    sRes = sVal;
    //идем по внешнему массиву и выдергиваем слова поиска
    for (var i in arrRepl){
       //искомое слово из массива - первый элемент массива
       wrd = arrRepl[i][0];
       //заменяем в выходной строке искомое слово на нужный вариант из справочника - второй элемент массива
       sRes = sRes.replace(new RegExp(wrd, 'gim'), arrRepl[i][1]);
    }
    
    //возвращаем результат
    return sRes;
};
*/
// удаляемa пробелы в конце и в начале
URLtoXML.trim = function(str) {
	while (str.charAt(str.length - 1) == " ") {
		str = str.substring(0, str.length - 1);
	}
	while (str.charAt(0) == " ") {
		str = str.substring(1);
	}
	return str;
};
