var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var pluginAPI = new Common.API.Plugin();
var currentFSMode = 2; 
var maxFSMode = 3;
var currentStatusLineText="";

var FS_Category = 
{
	SOUND_TRACKS : 0,			// Саундтреки
    FILMS : 1, 					// Фильмы
    CARTOONS : 2, 				// Мультфильмы
    CLIPS : 3, 					// Клипы
    SOAP_OPERAS : 4, 			// Сериалы
    THE_ANIMATED_SERIES : 5, 	// Мультсериалы
    TV_SHOWS : 6, 				// Телепередачи
    CONCERTS : 7,				// Концерты
    COLLECTIONS : 8,			// Сборники
    ALBUMS : 9					// Альбомы
};

var FS_CategoryWords = ["Саундтреки", 
                        "Фильмы", 
                        "Мультфильмы", 
                        "Клипы", 
                        "Сериалы",
                        "Мультсериалы", 
                        "Телепередачи", 
                        "Концерты", 
                        "Сборники", 
                        "Альбомы"];

var FS_Category_URL = ["/audio/soundtracks/",
					   "/video/films/",
					   "/video/cartoons/",
					   "/video/clips/",
					   "/video/serials/",
					   "/video/cartoonserials/",
					   "/video/tvshow/",
					   "/video/concerts/",
					   "/audio/collections/",
					   "/audio/albums/"];

showHandler = function() {
	// procedure OK
	// Стандартный индикатор громкости
	document.getElementById('pluginObjectNNavi').SetBannerState(1);
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
//	pluginAPI.unregistKey(tvKey.KEY_CHLIST);
	pluginAPI.setOffScreenSaver();
};

var Main = {
	version_vidget : "0.4.4",
	type_vidget : "",  // _s - серверная версия нужна для инфы об обновлениях
	mode : 0, // состояние полноэкранного режима
	WINDOW : 0,
	FULLSCREEN : 1,
	MATERIALL : 1,  //1 - видео где есть веб версия 2- аудио где ее нету

	sURL : "", // адрес страниы альбома
	index : 1, // номер активного канала
	smeh : 5, // смещение при перемещении верх-низ на странице
	page : 0, // номер строки с общими списками

	listRowsPerPage : 19, // количество строк в листе
	listheight : 455, // высота блока list Main.css
	playlist : 0,
	sta : 0, // 0 - пауза, 1 - играть с начала, 2 - продолжить с места остановки

	prefixURL : "http://brb.to",
	janrURL : "http://brb.to/video/films/",
	janrText : "Фильмы",
//	janrURL : "http://fs.ua/video/films/search.aspx?search=revenge",
	search : false, // search : false, search : true,
	resMore: false, // 15 рез. если true и 20 если false
	
	TVPlugin : 0,
	Audio : 0,
	audio_output_device : 0,
	hardware : 0,
	hardware_type : 0,
	serieC : false,
	serieE : false,
	serieB : false,
	serieText:"", // текстовая версия ТВ
	
	sort: 1, // сортировка 0 - по дате, 1 - по рейтингу, 2 - по году
	mnCurrentCategory : FS_Category.FILMS,
	mbIsCategories : false,
	mbInDevelopment : false,
	
	arr_hardware_char : ["C", "D", "B"],  //Старые версии ТВ
	
/*	mute : 0,
    NMUTE : 0,
    YMUTE : 1
  */
	keybMode : false,
	customKeyb : true, // true - custom QWERTY keyboard, false - default Samsung keyboard
	resumePlayVisible : false,
};

var b = 1; // индекс активной строки
var c = 1; // индекс прошлой активной строки
var url = ""; // адрес стрима файла mp3

Main.onLoad = function() {
	window.onShow =  showHandler; // Стандартный индикатор Volume-OSD
/*	this.Audio = document.getElementById('pluginAudio');
	this.audio_output_device = this.Audio.GetOutputDevice();
*/	this.TVPlugin = document.getElementById("pluginTV");
	this.hardware_type = this.TVPlugin.GetProductType();
	this.hardware = this.TVPlugin.GetProductCode(1);
	this.hardware_char=this.hardware.substring(4,5);
	
	if (Player.init() && Audio.init() && Display.init()) {
		
		document.getElementById("main").style.display = "block";
		document.getElementById("anchor").focus(); // Помещение фокуса на элемент "anchor"
		widgetAPI.sendReadyEvent();// Сообщаем менеджеру приложений о готовности
		
		document.getElementById("playlist").style.display = "none";
		document.getElementById("plain").style.display = "none";
		document.getElementById("search").style.display = "none";
		document.getElementById("black").style.display = "none";
		widgetAPI.putInnerHTML(document.getElementById("vidget_ver"),"Model:"+this.hardware+"   Type:"+this.hardware_char+"   v."+Main.version_vidget+Main.type_vidget);
		
		// адрес запроса
		if(this.search){
			this.sURL = this.janrURL;
		}else{
			this.sURL = this.janrURL + '?page=' + this.page + '&sort='+Main.getSortPar();
		}

		URLtoXML.Proceed(this.sURL);
		
		//Display.setTime(0); // выставляем 0:00:00/0:00:00
		//Display.setVolume( Audio.getVolume() ); // громкости
	//	$('#svecKeyHelp_IIZH').sfKeyHelp({'TOOLS' : 'Поиск','NUMBER' : 'Категория',	'UPDOWN' : 'Позиция','leftright' : 'Позиция','Enter' : 'Выбор',	'Exit' : 'Выход'});
		//Display.help_line_1();
	
	}
	
	if (this.customKeyb) {
		Keyboard.init(Search.onEnter);
	}
	
	Main.include();
	Info.open();
};

//Вставка клавиатуры
Main.include = function() {
    var html_doc = document.getElementsByTagName('head').item(0);
    var js = document.createElement('script');
	if(Main.arr_hardware_char.indexOf(Main.hardware_char)>-1){
		var urljs = '$MANAGER_WIDGET/Common/IME/ime2.js';
	}else{
		var urljs = '$MANAGER_WIDGET/Common/IME_XT9/ime.js';
	}
    js.setAttribute('language', 'javascript');
    js.setAttribute('type', 'text/javascript');
    js.setAttribute('src', urljs);
    html_doc.appendChild(js);
	
	return false;
};

Main.onUnload = function() {
	Player.deinit();
	URLtoXML.deinit();
};

Main.keyDown = function() {
	var keyCode = event.keyCode;
	
	if(Main.mbInDevelopment && (keyCode != tvKey.KEY_RETURN))
	{
		return;
	}
	
	switch (keyCode) {
	
	case tvKey.KEY_EXIT:
		//alert("KEY_EXIT");
		widgetAPI.blockNavigation(event); //отменяем заводскую реакцию на событие.
		
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			Player.stopVideo();
			Main.setWindowMode();			
		} else {
			widgetAPI.sendReturnEvent();// <- выполняем выход из виджета ВОЗВРАТОМ в смартхаб - вместо закрытия смартхаба по widgetAPI.sendExitEvent();
		}
		
		break;
		
	case tvKey.KEY_TOOLS:
	case tvKey.KEY_GUIDE: // поиск
		if (this.playlist == 0){
			// если мы 0-м уровне - поиск работает.
			document.getElementById("title").style.display = "none";
			document.getElementById("janr").style.display = "none";
			document.getElementById("search").style.display = "block";
			document.getElementById("plain").style.display = "block";
			document.getElementById("black").style.display = "block";
			document.getElementById("help_line_3").style.display="block";
			this.page = 0;
			if (this.customKeyb) {
				if (!Keyboard.run) {
					Keyboard.cyr = true;
					Keyboard.show();
				} else {
					Keyboard.callback(Keyboard.str);
				}
			} else {
				Search.Input();
			}
		};
//		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN){
//			pluginAPI.ShowTools(1);
//		}

		break;
		
	case tvKey.KEY_1:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(1);
		} 
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.FILMS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_2:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(2);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.CARTOONS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_3:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(3);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.CLIPS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_4:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(4);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.SOAP_OPERAS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_5:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(5);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.THE_ANIMATED_SERIES;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_6:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(6);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.TV_SHOWS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_7:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(7);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.CONCERTS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 1;
		}
		break;
		
	case tvKey.KEY_8:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(8);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.COLLECTIONS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 2;
		}
		break;
		
	case tvKey.KEY_9:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.PercentJump(9);
		}
		else if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0) {
			Main.mnCurrentCategory = FS_Category.ALBUMS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 2;
		}
		break;
		
	case tvKey.KEY_0:
		if (this.keybMode && this.customKeyb) {
			break;
		}
		else if (this.playlist == 0){
			Main.mnCurrentCategory = FS_Category.SOUND_TRACKS;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
			Main.MATERIALL = 2;
		}
		break;
		
	case tvKey.KEY_INFO:
		if (this.mode==this.FULLSCREEN){
			Display.showplayer();
			Display.statusLine (currentStatusLineText);
		} else {
			if (Info.isVisible) {
				Info.close();
			} else {
				Info.open();
			}
		}
		break;
		
	case tvKey.KEY_RED:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN) {
			Player.nextaudio();
		}
		else if (this.keybMode && this.customKeyb) {
			Keyboard.langChange();
		}
		else if (this.playlist == 0) {
			Favorites.open();
		} 
		else if (this.playlist == 2 && this.mode != this.FULLSCREEN) {
			url = URLtoXML.WpUrlSt[b];
			if(url != null && url != undefined) {
				if(Main.getResumeTime() > 0) {
					if(!this.resumePlayVisible) {
						Display.showResumePlay();
					} else {
						Display.hideResumePlay();
						Main.handlePlayKey(url);
						Display.showplayer();
					}
				} else {
					this.sta = 1;
					Main.handlePlayKey(url);
					Display.showplayer();
				}
			} else {
				Display.statusLine("Нету упрощенной версии.");
			}
		};
		break;
		
	case tvKey.KEY_YELLOW:
		if (this.keybMode && this.customKeyb) {
			Keyboard.backSpace();
		}
		else if (Favorites.isVisible) {
			Favorites.del();
		} else {
			Favorites.add();
		}
		break;
		
	case tvKey.KEY_BLUE: // переключение типа полноэкранного режима (циклично от 1 до 5, начальное значение 2)
		if (this.keybMode && this.customKeyb) {
			Keyboard.clear();
		}
		else if (this.playlist == 0 && !this.search && !Favorites.isVisible){
			Main.sortSelectNext();
		} else {
		    if (this.mode == this.WINDOW) { // не переключаем в свернутом режиме
    			break;
    		} else {
			    currentFSMode = (currentFSMode < maxFSMode) ? currentFSMode + 1 : 1;
			    Player.setScreenMode(currentFSMode);
    		}
		}
		break;
		
	case tvKey.KEY_GREEN: // Показать жанры
		if (this.keybMode && this.customKeyb) {
			Keyboard.shiftChange();
		}
		else if (this.playlist == 0 && !this.search && !Favorites.isVisible) {
			FS_Genres.ShowGenresForCategory(this.mnCurrentCategory);
		}
		break;
		
	case tvKey.KEY_ASPECT: // переключение типа полноэкранного режима (циклично от 1 до maxFSMode , начальное значение 2)
		if (this.mode == this.WINDOW) { // не переключаем в свернутом режиме
			break;
		}
		else{
			currentFSMode = (currentFSMode < maxFSMode) ? currentFSMode + 1 : 1;
			Player.setScreenMode(currentFSMode);
			break;
		}

	case tvKey.KEY_STOP:
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN){
			Player.stopVideo();
			Main.setWindowMode();
		}
		break;

	case tvKey.KEY_PAUSE:
		if (Player.getState() == Player.PLAYING) {
			this.handlePauseKey();
		}
		break;

	case tvKey.KEY_PLAY:
		if (Player.getState() != Player.PLAYING && this.mode == this.FULLSCREEN) {
			Main.handlePlayKey(url);
			this.sta = 1; // играть c начала
		}
		break;
		
	case tvKey.KEY_FF:
		if(Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			Player.skipForwardVideo();
		}
		break;
		
	case tvKey.KEY_RW:
		if(Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			Player.skipBackwardVideo();
		}
		break;

	case tvKey.KEY_RETURN:
	case tvKey.KEY_PANEL_RETURN:
		widgetAPI.blockNavigation(event); // блокируем по умолчанию RETURN 
		
		if ((Player.getState() == Player.PLAYING || Player.getState() == Player.PAUSED) && this.mode == this.FULLSCREEN)
		//если смотрим фильм - в любом раскладе играет или пауза - выходим. экономим на нажатии кнопки СТОП
		//зачем надо проверять режим проигрывания - на понял - по идее хватает проверки полноэкранности, но сделал  по аналогии 
		{
			Player.stopVideo();
			Main.setWindowMode();
			break;
		};
		
		if (this.keybMode && this.customKeyb) {
			Keyboard.returnKey();
			break;
		}
		
		if(this.resumePlayVisible) {
			Display.hideResumePlay();
			break;
		}
		
		if (URLtoXML.folders.length==0 && this.playlist==2) {
			this.playlist=1;
		}

		if (URLtoXML.folders.length>0){
			delete URLtoXML.folders[URLtoXML.folders.length-1];
			URLtoXML.folders.length--;
		}

		if (URLtoXML.folders.length>0 && this.playlist==1){
			delete URLtoXML.folders[URLtoXML.folders.length-1];
			URLtoXML.folders.length--;
		} else if (URLtoXML.folders.length==0 && this.playlist<2){ 
			this.playlist=0;
		} else { 
			this.playlist=1; 
		}

		if(this.playlist==0){
			
			// Закрываем "Избранное" и "Поиск"
			if(document.getElementById("spisok").style.display == "block"){
				if (Favorites.isVisible || this.search){
					this.search = false;
					Favorites.isVisible = false;
					Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
				}
			}
			
//			widgetAPI.blockNavigation(event); // блокируем по умолчанию RETURN
			document.getElementById("spisok").style.display = "block";
			document.getElementById("playlist").style.display = "none";
//			URLtoXML.Proceed(this.sURL);
				
		} else {
			Main.handleActiv();
			for ( var h = 1; h <= 200; h++) {
				widgetAPI.putInnerHTML(document.getElementById("str" + h), "");
			}

			URLtoXML.xmlHTTP = null;

			if (URLtoXML.folders.length==0){
//				this.sURL = URLtoXML.UrlSt[this.index]; // адрес страницы альбома
				URLtoXML.Proceed(URLtoXML.UrlSt[this.index]+'?ajax&folder=0');
			}else{
				var currIDX = URLtoXML.folders[URLtoXML.folders.length-1].currIdx-1;
				URLtoXML.Proceed(URLtoXML.folders[URLtoXML.folders.length-1].urls[currIDX]);
			}
		}
		
		if (Info.isVisible)
		{
			Info.close();
		}
		
		if(Main.mbInDevelopment)
		{
			Main.mbInDevelopment = false;
		}
		
		if(Main.mbIsCategories)
		{
			Main.mbIsCategories = false;	
		}
		
		if(FS_Genres.isVisible)
		{
			FS_Genres.isVisible = false;	
		}
		
		break;

	case tvKey.KEY_LEFT: // лево
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN){
			Player.skipBackwardVideoFast();
		}
		else if (this.keybMode && this.customKeyb) {
			Keyboard.setLeft();
		}
		else if(this.resumePlayVisible) {
			Display.resumePlay(true);
		}
		else {
			if (this.playlist == 0 && this.index>0) {
				if (this.index == 1) {
					this.smeh = Main.NewString(0, -1) ? (this.resMore?19:14) : 0;
					this.index = 1;
					Main.ActivString(this.smeh);
				} else {
					Main.ActivString(-1);
				}
			} else if ((this.playlist == 1 || this.playlist == 2) && this.index>0) {
				Main.selectUpPageVideo();
				if (this.playlist == 1){
					URLtoXML.folders[URLtoXML.folders.length-1].currIdx = b;
				}
			}
		}
		break;

	case tvKey.KEY_RIGHT: // право
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			Player.skipForwardVideoFast();
		}
		else if (this.keybMode && this.customKeyb) {
			Keyboard.setRight();
		}
		else if(this.resumePlayVisible) {
			Display.resumePlay(false);
		}
		else {
			if (this.playlist == 0 && this.index<URLtoXML.ImgDickr.length) {
				if (this.index == (this.resMore?20:15)) {
					this.index = 1;
					Main.NewString(0, 1);
					Main.ActivString(0);
				} else if (this.index<URLtoXML.ImgDickr.length-1) {
					Main.ActivString(1);
				}
			} else if (this.playlist == 1 || this.playlist == 2) {
				Main.selectNextPageVideo();
				if (this.playlist == 1){
					URLtoXML.folders[URLtoXML.folders.length-1].currIdx = b;
				}
			}
		}
		break;

	case tvKey.KEY_UP:
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			// переключение типа полноэкранного режима
			currentFSMode = (currentFSMode < maxFSMode) ? currentFSMode + 1 : 1;
			Player.setScreenMode(currentFSMode);
			break;
		} 
		else if (this.keybMode && this.customKeyb) {
			Keyboard.setUp();
		}
		else if (this.playlist == 0) {
			this.smeh = this.resMore?-7:-5;
			if (this.index>0 && this.index<=(this.resMore?7:5)) {
				Main.NewString(this.resMore?14:10, -1);
			}// переход поиска вверх
			Main.ActivString(this.smeh);// активная строка
		} else if (this.playlist == 1 || this.playlist == 2) {
			Main.selectUpVideo();
			if (this.playlist == 1){
				URLtoXML.folders[URLtoXML.folders.length-1].currIdx = b;
			}
		}
		break;

	case tvKey.KEY_DOWN:
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			// устанавливаем изменение размера изображения (в обратном порядке) на кнопку "Вниз"
			currentFSMode = (currentFSMode > 1) ? currentFSMode - 1 : maxFSMode;
			Player.setScreenMode(currentFSMode);
		} 
		else if (this.keybMode && this.customKeyb) {
			Keyboard.setDown();
		}
		else if (this.playlist == 0) {
			this.smeh = this.resMore?7:5;
			if (this.index>(this.resMore?14:10) && this.index<=(this.resMore?20:15)) {
				Main.NewString((this.resMore?-14:-10), 1);// переход поиска вниз
			}

			if (this.index+this.smeh<URLtoXML.ImgDickr.length && this.index+this.smeh>0)
				Main.ActivString(this.smeh);// активная строка
		} else if (this.playlist == 1 || this.playlist == 2) {
			if (this.playlist == 1){
				if (b>=URLtoXML.folders[URLtoXML.folders.length-1].urls.length) break;
			}else{
				if (b>=URLtoXML.pUrlSt.length-1) break;
			}
			Main.selectNextVideo();
			this.sta = 1; // играть c начала

			if (this.playlist == 1){
				URLtoXML.folders[URLtoXML.folders.length-1].currIdx = b;
			}
		}
		break;

	case tvKey.KEY_ENTER:
	case tvKey.KEY_PANEL_ENTER:
		//Info.close();
		
		if (Favorites.isVisible){
			//Display.help_line_2_1();
		} else {
			//Display.help_line_2();
		}
		
		if (this.keybMode && this.customKeyb) {
			Keyboard.addKey();
		}
		else if (this.playlist == 0) {
			this.playlist = 1;
			Main.handleActiv();
			for ( var h = 1; h <= 200; h++) {
				widgetAPI.putInnerHTML(document.getElementById("str" + h), "");
			}

			URLtoXML.xmlHTTP = null;
			URLtoXML.Proceed(URLtoXML.UrlSt[this.index]+'?ajax&folder=0');
			document.getElementById("spisok").style.display = "none";
			document.getElementById("playlist").style.display = "block";
			document.getElementById("descript").style.display = "block";
			
			widgetAPI.putInnerHTML(document.getElementById("description"),
				"<img align='left' src='"
					+ URLtoXML.ImgDickr[this.index] + "'/>"
					+ URLtoXML.pDes[this.index]);
			
		} else if (this.playlist == 1) {
			
			if(this.mbIsCategories)
			{
				FS_Genres.SelectGenre();				
			}
			else
			{
				Main.handleActiv();
				for ( var h = 1; h <= 200; h++) {
					widgetAPI.putInnerHTML(document.getElementById("str" + h), "");
				}

				URLtoXML.xmlHTTP = null;			
				var currIDX = URLtoXML.folders[URLtoXML.folders.length-1].currIdx-1;
				URLtoXML.Proceed(URLtoXML.folders[URLtoXML.folders.length-1].urls[currIDX]);
			}
			
		} else if (this.playlist == 2) {
			// установка воспроизведения/паузы на кнопку ентер
			if(this.mode == this.FULLSCREEN){
				if (Player.getState() != Player.PLAYING){
					this.handlePlayKey();
				} else {
					this.handlePauseKey();
				};
			} else {
				if(!this.resumePlayVisible) {
					url = URLtoXML.pUrlSt[b];
				}
				
				if(Main.getResumeTime() > 0) {
					if(!this.resumePlayVisible) {
						Display.showResumePlay();
					} else {
						Display.hideResumePlay();
						Main.handlePlayKey(url);
						Display.showplayer();
					}
				} else {
					this.sta = 1;
					Main.handlePlayKey(url);
					Display.showplayer();
				}
			}
		};

/*
		widgetAPI.putInnerHTML(document.getElementById("description"),
				"<img style='border-style: solid; border-width:10px; border-color:#3399FF; margin:10px; max-width: 200px; max-height: 200px;  border-radius:5px; box-shadow:0 0 13px black;' src='"
					+ URLtoXML.ImgDickr[this.index].replace("?100", "100")
					+ "max-width: 200px; max-height: 200px; ' align='left'"
					+ URLtoXML.pDes[this.index]);
*/
		break;
		
	case tvKey.KEY_CHLIST:
		if (this.keybMode && this.customKeyb) {
			Keyboard.change();
		}
		else if (this.playlist == 0) {
			Favorites.open();
		}
		break;

	case tvKey.KEY_CH_UP: 
	case tvKey.KEY_PANEL_CH_UP:
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			// переключение на следующий трек/видео файл
			if (b>=URLtoXML.pUrlSt.length-1) break;
			Main.selectNextVideo();
			url = URLtoXML.pUrlSt[b];
			Main.handlePlayKey(url);
			Display.showplayer();
		} 
		else if (this.keybMode && this.customKeyb) {
			Keyboard.change();
		}
		else if (this.playlist == 0) {
			// переключение разделов сайта (Видео, Музыка, Сериалы и т.д.)
			Main.mnCurrentCategory = (Main.mnCurrentCategory < 9) ? Main.mnCurrentCategory + 1 : 0;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
		}
		break;
		
	case tvKey.KEY_CH_DOWN: 
	case tvKey.KEY_PANEL_CH_DOWN:
		if (Player.getState() == Player.PLAYING && this.mode == this.FULLSCREEN) {
			// переключение на предыдущий трек/видео файл
			if (b<=1) break;
			Main.selectUpVideo();
			url = URLtoXML.pUrlSt[b];
			Main.handlePlayKey(url);
			Display.showplayer();
		}
		else if (this.keybMode && this.customKeyb) {
			Keyboard.change();
		}
		else if (this.playlist == 0) {
			// переключение разделов сайта (в обратном порядке) (Видео, Музыка, Сериалы и т.д.)
			Main.mnCurrentCategory = (Main.mnCurrentCategory > 0) ? Main.mnCurrentCategory -1 : 9;
			Main.NewJanr(this.prefixURL + FS_Category_URL[Main.mnCurrentCategory], FS_CategoryWords[Main.mnCurrentCategory]);
		}
		break;
			
	default:
//		alert("Unhandled key");
		break;
	}
	
	if (URLtoXML.sName[this.index]) {
		if (URLtoXML.sName[this.index].length > 180) {
			widgetAPI.putInnerHTML(document.getElementById("title"), URLtoXML.sName[this.index].substr(0, 180) + "...");
		} else {
			// название в заголовок
			widgetAPI.putInnerHTML(document.getElementById("title"), URLtoXML.sName[this.index]);
		}
	}
	
	Info.load();
	
	Main.ListTop();
};

// перемещение поиска по страницам
Main.NewString = function(per, a) {
//	this.search = "?";
	this.smeh = per; // соответствие столбца
	this.page = this.page + a; // смещаем адрес поиска страницы
	if (this.page < 0) {// верхний предел
		this.page = 0;
		this.smeh = 0;
		return 0;
	} else if (Favorites.isVisible) {
		return Favorites.changePage();
	}else{
		widgetAPI.putInnerHTML(document.getElementById("title"), "");
/*		for ( var h = 1; h <= 20; h++) {
			widgetAPI.putInnerHTML(document.getElementById("bloc" + h), "");
		}
*/		
		URLtoXML.xmlHTTP = null;
		
		var url = '';
		if (this.search){
			url = this.sURL + '&page=' + this.page;
		}else{
			url = this.janrURL + '?page=' + this.page + '&sort='+Main.getSortPar(); // жанр
		}
		// +
		// страница
		URLtoXML.Proceed(url);
		return 1;
	}
};

// активная строка
Main.ActivString = function(smeh) {
	this.smeh = smeh;
	if (document.getElementById("imgst" + this.index)) {
		document.getElementById("imgst" + this.index).style.borderColor = "#e9e9e9";
	}
	
	this.index = this.index + this.smeh;
	if (document.getElementById("imgst" + this.index)) {
		// document.getElementById("imgst" + this.index).style.borderColor = "#3399FF";
		document.getElementById("imgst" + this.index).style.borderColor = "#FF6600"; // цвет активного блока
	}
};

Main.ListTop = function() { // смещение списка по достижению пределов
	document.getElementById("list2").style.top = (-this.listheight * Math.floor((b-1)/this.listRowsPerPage))+"px";
};

Main.handlePauseKey = function() {
	switch (Player.getState()) {
	case Player.PLAYING:
		Player.pauseVideo();
		this.sta = 0; // пауза
		break;
	default:
		break;
	}
};

Main.handleActiv = function() {
	document.getElementById("list2").style.top = "0px"; // переключение списка
	// на 0
	document.getElementById("str" + b).class = '';
	// цвета с
	// активного на
	// пасивный
	b = 1;
	c = 1;
	document.getElementById("str" + b).class = 'selected';
	// строка
};
Main.selectNextVideo = function() {
	if (b < 200) {
		c = b;
		document.getElementById("str" + c).class = '';
		b++;
		document.getElementById("str" + b).class = 'selected';
		this.sta = 1;// играть c начала
	}
};
Main.selectUpVideo = function(){
	if (b > 1) {
		c = b;
		document.getElementById("str" + c).class = '';
		b--;
		document.getElementById("str" + b).class = 'selected';
		this.sta = 1;// играть c начала
	} 	
};

Main.selectNextPageVideo = function() {
	if (b < 200) {
		c = b;
		document.getElementById("str" + c).class = '';
		b+=this.listRowsPerPage;
		if (this.playlist == 1){
			if (b>=URLtoXML.folders[URLtoXML.folders.length-1].urls.length)
				b=URLtoXML.folders[URLtoXML.folders.length-1].urls.length;
		}else{
			if (b>=URLtoXML.pUrlSt.length-1)
				b=URLtoXML.pUrlSt.length-1;
		}
		if (b>200) b=200;
		document.getElementById("str" + b).class = 'selected';
		this.sta = 1;// играть c начала
	} // предел max
};
Main.selectUpPageVideo = function(){
	if (b > 1) {
		c = b;
		document.getElementById("str" + c).class = '';
		b-=this.listRowsPerPage;
		if (b<1) b=1;
		document.getElementById("str" + b).class = 'selected';
		this.sta = 1;// играть c начала
	}
};

Main.handlePlayKey = function(url)
{
	if (this.sta == 1 || this.sta == 2) {
		Player.stopVideo();
		url = URLtoXML.pUrlSt[b];
		Player.playVideo(url);
	}
	switch (Player.getState()) {
	case Player.STOPPED:
		Player.playVideo(url);
		break;
	case Player.PAUSED:
		Player.resumeVideo();
		break;
	default:
		break;
	}
/*	
	widgetAPI.putInnerHTML(document.getElementById("description"),
		"<img style='border-style: solid; border-width:10px; border-color:#3399FF; margin:10px; max-width: 200px; max-height: 200px; border-radius:5px; box-shadow:0 0 13px black;' src='"
			+ URLtoXML.ImgDickr[this.index].replace("?100", "100")
			+ "max-width: 200px; max-height: 200px; ' align='left'"
			+ URLtoXML.pDes[this.index]
	);
*/
	Main.ListTop();// смещение списка по достижению пределов
};

// перемещение поиска по страницам
Main.NewJanr = function(janr, text) {
	this.search = false;
	Favorites.isVisible = false;
	
	Main.setResSimple();
	Main.clearBlocks();
	
	this.page = 0;
	
	this.janrURL = janr;
	this.janrText = text;
	
	URLtoXML.xmlHTTP = null;
	this.sURL = janr + '?page=' + this.page + '&sort='+Main.getSortPar(); // жанр +
	// страница
	URLtoXML.Proceed(this.sURL);
	widgetAPI.putInnerHTML(document.getElementById("janr"), text+" <span id=\"filter\" style=\"color:#3399FF; font-size:15px;\">("+Main.getSortText()+")</span>");
	//Display.help_line_1();
};

Main.setFullScreenMode = function() {
	if (this.mode != this.FULLSCREEN) {
		document.getElementById("main").style.display = "none";
//		Player.setFullscreen();
		this.mode = this.FULLSCREEN;
	}
};

Main.setWindowMode = function() {
	if (this.mode != this.WINDOW) {
		Display.hideplayer();
		Player.setWindow();
		document.getElementById("main").style.display = "block";
		document.getElementById("fon").style.display="none";
		this.mode = this.WINDOW;
	}
};

Main.toggleMode = function() {
	switch (this.mode) {
	case this.WINDOW:
		this.setFullScreenMode();
		break;

	case this.FULLSCREEN:
		this.setWindowMode();
		break;

	default:
		break;
	}
};

Main.setResSimple = function() {
	document.getElementById("spisok2").class = '';
	document.getElementById("spisok2").className = '';
	this.resMore = false;
};

Main.setResMore = function() {
    document.getElementById("spisok2").class = 'moreres';
	document.getElementById("spisok2").className = 'moreres';
	this.resMore = true;
};

Main.clearBlocks = function(){
	widgetAPI.putInnerHTML(document.getElementById("title"), '');
	for ( var h = 1; h <= 20; h++) {
		widgetAPI.putInnerHTML(document.getElementById("bloc" + h), "");
	}
	Main.index = 1;
	URLtoXML.ImgDickr = [];
	URLtoXML.UrlSt = [];
	URLtoXML.sName = [];
	URLtoXML.pDes = [];
};

Main.getSortPar = function(){
	var res = 'new';
	switch(this.sort){
		case 1: res = 'rating'; break;
		case 2: res = 'year'; break;
	}
	return res;
};

Main.getSortText = function(){
	var res = 'по дате';
	switch(this.sort) {
		case 1: res = 'по рейтингу'; break;
		case 2: res = 'по году'; break;
	}
	return res;
};

Main.sortSelectNext = function(){
	if (this.sort<2){
		this.sort++;
	}else{
		this.sort=0;
	}
	Main.NewJanr(this.janrURL, this.janrText);
};

Main.showLoading = function(type){
	if (type){
		document.getElementById("loadingDescr").style.display = "";
	}else{
		document.getElementById("loading").style.display = "";
	}
};

Main.hideLoading = function(type){
	if (type){
		document.getElementById("loadingDescr").style.display = "none";
	}else{
		document.getElementById("loading").style.display = "none";
	}
};

Main.getResumeTime = function(type){
	Player.seekTime = 0;
	for(var i = 0; i < Player.resumeTime.length; i++) {
		if (Player.resumeTime[i].url == url) {
			Player.seekTime = Player.resumeTime[i].time;
		}
	}
	
	return Player.seekTime;
};
